{% extends "base.html" %}
{% block content %}

<script src="/static/formBuilder/form-render.min.js"></script>

<div class="container">
    <div class="row col-md-6">
        <div style="font-size:1.5em;">
            {%trans%}Form{%endtrans%}: {{ form.slug }}
        </div> 
        <hr />
          
        <div id="fb-render"></div>

        <div id="dataConsent" class="formDataConsent" {% if not form.isDataConsentEnabled() %}style="display:none;"{% endif %}>
            {{ form.dataConsent|safe }}
            {%trans%}I agree{%endtrans%}
            <input type="checkbox" style="position:relative; top:3px;" required />
        </div>

        <input class="btn-success btn" type="submit" value="{%trans%}Send{%endtrans%}" disabled />
        
        <p>&nbsp;</p>
        <div style="font-size:1.4em">
            {%trans%}Post-submit text{%endtrans%}
        </div>
        <hr />
        <div>
        {{ form.afterSubmitText['html'] | safe }}
        </div>
        
    </div>
    <div class="row col-md-1"></div> 
    <div class="row col-md-5">
        <div style="font-size:1.5em">
            {%trans%}Details{%endtrans%}
            {% if form.editors[g.current_user._id|string] is defined %}
            <input class="btn-primary btn btn-xs" type="button" value="{%trans%}View log{%endtrans%}" onClick="location.href='/forms/log/list/{{form._id}}'" >
            {% endif %}
        </div>
        <hr />
        
        <table class="table table-striped table-condensed">
            <tr>
               <td>{%trans%}Entries{%endtrans%}</td>
               <td>
                   {% if form.editors[g.current_user._id|string] is defined %}
                        <input class="btn-primary btn btn-xs" type="button" value="{%trans%}View{%endtrans%} {{form.totalEntries}} {%trans%}entries{%endtrans%}" onClick="location.href='/forms/entries/{{form._id}}'" >
                   {% else %}
                        {{form.totalEntries}}
                   {% endif %}
                   {% if form.totalEntries %}
                        {%trans%}Last{%endtrans%}: {{ form.lastEntryDate }}
                   {% endif %}
               </td>
            </tr>
            <tr>
               <td>{%trans%}Published{%endtrans%}</td>
               <td>
               {% if form.editors[g.current_user._id|string] is defined %}
                   <div id="toggle_enabled" class="btn-group btn-toggle">
                    <button id="enabled_true" class="btn btn-xs btn-default {% if form.isPublic() %}btn-success{% endif %}">{%trans%}True{%endtrans%}</button>
                    <button id="enabled_false" class="btn btn-xs btn-default {% if not form.isPublic() %}btn-primary{% endif %}">{%trans%}False{%endtrans%}</button>
                   </div>
               {% else %}
                    {{ form.isPublic() }}
                    {% if not form.user.enabled %}
                        <span style="color:red">({%trans%}user disabled{%endtrans%})</span>                
                    {% endif %}               
               {% endif %}
               </td>
            </tr>
            <tr>
               <td>{%trans%}Will expire{%endtrans%}</td>
               <td>
                   {% if form.editors[g.current_user._id|string] is defined %}
                        {% if form.expired %}
                            <input class="btn-warning btn btn-xs" type="button" value="{%trans%}Expired{%endtrans%}" onClick="location.href='/forms/expiration/{{form._id}}'" >
                        {% elif form.willExpire() %}
                            <input class="btn-success btn btn-xs" type="button" value="{%trans%}True{%endtrans%}" onClick="location.href='/forms/expiration/{{form._id}}'" >
                        {% else %}
                            <input class="btn-primary btn btn-xs" type="button" value="{%trans%}False{%endtrans%}" onClick="location.href='/forms/expiration/{{form._id}}'" >
                        {% endif %}
                   {% else %}
                        {% if form.expired %}
                            {%trans%}Expired{%endtrans%}
                        {% elif form.willExpire() %}
                            {%trans%}True{%endtrans%}
                        {% else %}
                            {%trans%}False{%endtrans%}
                        {% endif %}
                   {% endif %}
               </td>
            </tr>
            <tr>
               <td>{%trans%}Public URL{%endtrans%}</td>
               <td>
                   {% if form.isPublic() %}
                   <a id="formLink" href="{{ form.url }}">{{ form.url }}</a>
                   <span id="formURL" style="display:none">{{ form.url }}</span>
                   {% else %}
                   <a id="formLink" href="{{ form.url }}" style="display:none">{{ form.url }}</a>
                   <span id="formURL">{{ form.url }}</span>
                   {% endif %}
                </td>
            </tr>
            <tr>
               <td>{%trans%}Shared{%endtrans%}</td>
               <td>
                   {% if form.editors[g.current_user._id|string] is defined %}
                        {% if form.isShared() %}
                        <input class="btn-success btn btn-xs" type="button" value="{%trans%}True{%endtrans%}" onClick="location.href='/forms/share/{{form._id}}'" >
                        {% else %}
                        <input class="btn-primary btn btn-xs" type="button" value="{%trans%}False{%endtrans%}" onClick="location.href='/forms/share/{{form._id}}'" >
                        {% endif %}
                   {% else %}
                        {{ form.isShared() }}
                   {% endif %}
               </td>
            </tr>
            <tr>
               <td>{%trans%}Restricted access{%endtrans%}</td>
               <td>
                   {% if form.editors[g.current_user._id|string] is defined %}
                        {% if form.data.restrictedAccess %}
                        <input class="btn-success btn btn-xs" type="button" value="{%trans%}True{%endtrans%}" onClick="location.href='/forms/share/{{form._id}}'" >
                        {% else %}
                        <input class="btn-primary btn btn-xs" type="button" value="{%trans%}False{%endtrans%}" onClick="location.href='/forms/share/{{form._id}}'" >
                        {% endif %}
                   {% else %}
                        {{ form.data.restrictedAccess }}
                   {% endif %}
               </td>
            </tr>
            {% if form.site.isPersonalDataConsentEnabled() %}
            <tr>
               <td>{%trans%}Require consent{%endtrans%}</td>
               <td>
               {% if form.editors[g.current_user._id|string] is defined %}
                   <div id="toggle_dataConsent" class="btn-group btn-toggle">
                    <button id="dataConsent_true" class="btn btn-xs btn-default {% if form.isDataConsentEnabled() %}btn-success{% endif %}">{%trans%}True{%endtrans%}</button>
                    <button id="dataConsent_false" class="btn btn-xs btn-default {% if not form.isDataConsentEnabled() %}btn-primary{% endif %}">{%trans%}False{%endtrans%}</button>
                   </div>
               {% else %}
                    {{ form.isDataConsentEnabled() }}            
               {% endif %}
               </td>
            </tr>
            {% endif %}
            <tr>
               <td>{%trans%}Author{%endtrans%}</td>
               {% if g.isAdmin %}
                    <td><a href="/admin/users/{{ form.user._id }}">{{ form.user.username }}</a></td>
               {% else %}
                    <td>{{ form.user.username }}</td>
                {% endif %}
            </tr>
            <tr>
               <td>{%trans%}Created{%endtrans%}</td>
               <td>{{ form.created }}</td>
            </tr>
            {% if g.isRootUser %}
            <tr>
                <td>{%trans%}Hostname{%endtrans%}</td>
                <td>{{ form.hostname }}</td>
            </tr>
            {% endif %}
            
        </table>
        {% if form.editors[g.current_user._id|string] is defined %}
        <hr />
        <input class="btn-primary btn btn-sm" type="button" value="{%trans%}Edit form{%endtrans%}" onClick="location.href='/forms/edit/{{ form._id }}'">
        <input class="btn-primary btn btn-sm" type="button" value="{%trans%}Duplicate form{%endtrans%}" onClick="location.href='/forms/duplicate/{{ form._id }}'">
        <p></p>
            {% if form.totalEntries == 0 %}
            <input class="btn-danger btn btn-sm" type="button" value="{%trans%}Delete form{%endtrans%}" onClick="location.href='/forms/delete/{{ form._id }}'">
            {% else %}
            <input class="btn-danger btn btn-sm" type="button" value="{%trans%}Delete form and entries{%endtrans%}" onClick="location.href='/forms/delete/{{ form._id }}'">
            {% endif %}
        {% endif %}
    </div>
</div>


<script>
var csrftoken = "{{ csrf_token() }}";
jQuery(function($) {
    var fbRender = document.getElementById('fb-render');
    var formData = {{ form.structure | tojson }};
    var formRenderOpts = {
        formData,
        dataType: 'json',
        notify: {
            success: function(message) {
                addRequiredMsg();
                return;
            }
        }
    };
    $(fbRender).formRender(formRenderOpts);
});

{% if form.editors[g.current_user._id|string] is defined %}
document.getElementById('toggle_enabled').addEventListener('click', function(evt){
    $.ajax({
        url : "/form/toggle-enabled/{{ form._id }}",
        type: "POST",
        dataType: "json",
        beforeSend: function(xhr, settings) {
            if (!/^(GET|HEAD|OPTIONS|TRACE)$/i.test(settings.type)) {
                xhr.setRequestHeader("X-CSRFToken", csrftoken)
            }
        },
        success: function(data, textStatus, jqXHR)
        {
            if (data.enabled == true) {
                $('#enabled_true').addClass('btn-success');
                $('#enabled_false').removeClass('btn-primary');
                $('#formURL').hide();
                $('#formLink').show();
            }
            else if (data.enabled == false) {
                $('#enabled_true').removeClass('btn-success');
                $('#enabled_false').addClass('btn-primary');
                $('#formURL').show();
                $('#formLink').hide();
            }
        }
    });
});
{% if form.site.isPersonalDataConsentEnabled() %}
    document.getElementById('toggle_dataConsent').addEventListener('click', function(evt){
        $.ajax({
            url : "/form/toggle-data-consent/{{ form._id }}",
            type: "POST",
            dataType: "json",
            beforeSend: function(xhr, settings) {
                if (!/^(GET|HEAD|OPTIONS|TRACE)$/i.test(settings.type)) {
                    xhr.setRequestHeader("X-CSRFToken", csrftoken)
                }
            },
            success: function(data, textStatus, jqXHR)
            {
                if (data.consent == true) {
                    $('#dataConsent_true').addClass('btn-success');
                    $('#dataConsent_false').removeClass('btn-primary');
                    $('#dataConsent').show();
                }
                else if (data.consent == false) {
                    $('#dataConsent_true').removeClass('btn-success');
                    $('#dataConsent_false').addClass('btn-primary');
                    $('#dataConsent').hide();
                }
            }
        });
    });
{% endif %}
{% endif %}
function addRequiredMsg(){
    if ($('#fb-render').find("span.fb-required").length) {
        var firstGroup = $('#fb-render').find('.form-group').filter(':visible:first');
        if (firstGroup.length) {
            $("<div class='required'>● {%trans%}Required fields{%endtrans%}</div>").insertBefore(firstGroup);
        }
    }    
}
</script>
  
{% endblock %}
